//	C++/CLI		OpenGL

#include <windows.h>
#using "tugamegl.dll"
using namespace System;
using namespace jp::netgamers::free::tugame;	//	ٍ색Cu

public ref class ochimono : TUGame
{
	static array<unsigned int>^	m_argb = { 0xff000000, 0xffffffff, 0xff00ff00 };
	static array<char>^			m_field = gcnew array<char>( WIDTH * HEIGHT );

	static const int		WIDTH = 10;
	static const int		HEIGHT = 20;

	static int				m_x, m_y;

	//	NCxgʒm
	public: virtual void wmLoad() override
	{
		setStartLocation( 0, 61 );	//	ÑEBhEʒuBLv`s
		setBackground( 0xff005555 );

		for( int x = 1; x < WIDTH - 1; x++ ){
			setField( x,          1, 1 );
			setField( x, HEIGHT - 2, 1 );
		}

		for( int y = 1; y < HEIGHT - 1; y++ ){
			setField(         1, y, 1 );
			setField( WIDTH - 2, y, 1 );
		}

		m_x = WIDTH / 2;
		m_y = 2;

		setFrameRate( 10 );
	}

	//	`Cxgʒm
	public: virtual void wmPaint() override
	{
		for( int y = 0; y < HEIGHT; y++ ){
			for( int x = 0; x < WIDTH; x++ ){
				drawBlock( x, y, getField( x, y ) );
			}
		}

		drawBlock( m_x, m_y, 2 );
	}

	//	^C}[Cxgʒm
	public: virtual void wmTimer() override
	{
		if( TUKeyPad::isRight() )	m_x++;
		if( TUKeyPad::isLeft() )	m_x--;
		if( TUKeyPad::isDown() )	m_y++;

		if( TUKeyPad::isA() ){
			setField( m_x, m_y, 2 );
			if( isLine( m_y ) ){
				clearLine( m_y );
			}
		}

		repaint();
	}

	void drawBlock( int x, int y, byte t )
	{
		setColor( m_argb[ t ] );			//	`Fݒ
		fillRect( x * 15, y * 15, 14, 14 );	//	``
	}

	boolean isLine( int y )
	{
		for( int x = 2; x < WIDTH - 2; x++ ){
			if( getField( x, y ) == 0 ){
				return( false );
			}
		}
		return( true );
	}

	void clearLine( int y )
	{
		for( int x = 2; x < WIDTH - 2; x++ ){
			setField( x, y, 0 );
		}
	}

	char getField( int x, int y )
	{
		return( m_field[ y * WIDTH + x ] );
	}

	void setField( int x, int y, char t )
	{
		m_field[ y * WIDTH + x ] = t;
	}

};

void main()
{
	TUGame::setClientSize( 480, 360 );	//	EBhETCYݒ
	gcnew ochimono();
}
